package com.gamefocal.rivenworld.game.items.placables.blocks.Stone;

import com.gamefocal.rivenworld.entites.net.HiveNetConnection;
import com.gamefocal.rivenworld.game.GameEntity;
import com.gamefocal.rivenworld.game.entites.blocks.Stone.StoneRampBlock;
import com.gamefocal.rivenworld.game.interactable.InteractAction;
import com.gamefocal.rivenworld.game.interactable.Intractable;
import com.gamefocal.rivenworld.game.inventory.CraftingRecipe;
import com.gamefocal.rivenworld.game.inventory.InventoryCraftingInterface;
import com.gamefocal.rivenworld.game.inventory.enums.InventoryDataRow;
import com.gamefocal.rivenworld.game.items.generics.PlaceableInventoryItem;
import com.gamefocal.rivenworld.game.recipes.blocks.Stone.StoneRampBlockRecipe;

public class StoneRampBlockItem extends PlaceableInventoryItem<StoneRampBlockItem> implements InventoryCraftingInterface {

    public StoneRampBlockItem() {
        this.name = "Stone Ramp";
        this.desc = "A ramp made of stone";
        this.icon = InventoryDataRow.StoneRamp_Block;
        this.mesh = InventoryDataRow.StoneRamp_Block;
        this.placable.IsBuildingBlock = true;
        this.spawnNames.add("stoneramp");
    }

    @Override
    public void onInteract(Intractable intractable, HiveNetConnection connection, InteractAction action) {

    }

    @Override
    public GameEntity spawnItem() {
        return new StoneRampBlock();
    }

    @Override
    public CraftingRecipe canCraft(HiveNetConnection connection) {
        return new StoneRampBlockRecipe();
    }
}
