package com.gamefocal.rivenworld.game.items.placables.blocks.Stone;

import com.gamefocal.rivenworld.entites.net.HiveNetConnection;
import com.gamefocal.rivenworld.game.GameEntity;
import com.gamefocal.rivenworld.game.entites.blocks.Stone.StoneStairBlock;
import com.gamefocal.rivenworld.game.interactable.InteractAction;
import com.gamefocal.rivenworld.game.interactable.Intractable;
import com.gamefocal.rivenworld.game.inventory.CraftingRecipe;
import com.gamefocal.rivenworld.game.inventory.InventoryCraftingInterface;
import com.gamefocal.rivenworld.game.inventory.enums.InventoryDataRow;
import com.gamefocal.rivenworld.game.items.generics.PlaceableInventoryItem;
import com.gamefocal.rivenworld.game.recipes.blocks.Stone.StoneStairsBlockRecipe;

public class StoneStairBlockItem extends PlaceableInventoryItem<StoneStairBlockItem> implements InventoryCraftingInterface {

    public StoneStairBlockItem() {
        this.name = "Stone Stairs";
        this.desc = "A stair made of stone";
        this.icon = InventoryDataRow.StoneStairs_Block;
        this.mesh = InventoryDataRow.StoneStairs_Block;
        this.placable.IsBuildingBlock = true;
        this.spawnNames.add("stonestairs");
    }

    @Override
    public void onInteract(Intractable intractable, HiveNetConnection connection, InteractAction action) {

    }

    @Override
    public GameEntity spawnItem() {
        return new StoneStairBlock();
    }

    @Override
    public CraftingRecipe canCraft(HiveNetConnection connection) {
        return new StoneStairsBlockRecipe();
    }
}
